<template>
  <Spinner v-if="loading"></Spinner>
  <template v-else>
    <VTable v-model:currentPage="currentPage" :data="computedData" :filters="filter" sortHeaderClass="flex items-center"
      class="w-full text-md text-left text-gray-500 dark:text-gray-300 border-t" :pageSize="10"
      @stateChanged="tableState = $event" @totalPagesChanged="totalPages = $event">
      <template #head class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
        <tr class="border-b">
          <VTh sortKey="submittedAt" defaultSort="desc" class="px-6 py-3">
            Submitted
          </VTh>
          <VTh sortKey="name" class="px-6 py-3"> Name </VTh>
          <th class="px-6 py-3">Description</th>
          <th class="px-6 py-3">Id</th>
          <th class="px-6 py-3">Process Path</th>
          <th class="px-6 py-3">Status</th>
          <th class=""></th>
        </tr>
      </template>
      <template #body="{ rows }">
        <tr v-for="row in rows" :key="row.id"
          class="border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-700 hover:cursor-pointer"
          @click="emit('clickRow', row)">
          <td class="px-6 py-2 font-medium text-gray-900 dark:text-white whitespace-nowrap">
            {{ datetimeFilter(row.submittedAt) }}
          </td>
          <td class="px-6 py-2">
            {{ row.name }}
          </td>
          <td class="px-6 py-2">
            {{ row.description }}
          </td>
          <td class="px-6 py-2">
            {{ row.id }}
          </td>
          <td class="px-6 py-2">
            {{ row.configuration ? row.configuration.processPath : "-" }}
          </td>
          <td class="px-6 py-2">
            {{
              row.executions && row.executions.length > 0
              ? row.executions[0].status
              : "unknown"
            }}
          </td>
          <td class="px-0 py-2">
            <RouterLink :to="{ name: 'submit' }" v-slot="{ navigate }">
              <div @click="setFromJobObject(row)" role="link"
                class="flex items-center hover:bg-blue-600 bg-blue-700 mr-4 px-4 py-2 rounded">
                <svg style="width: 24px; height: 24px" viewBox="0 0 24 24">
                  <path fill="currentColor"
                    d="M12,4C14.1,4 16.1,4.8 17.6,6.3C20.7,9.4 20.7,14.5 17.6,17.6C15.8,19.5 13.3,20.2 10.9,19.9L11.4,17.9C13.1,18.1 14.9,17.5 16.2,16.2C18.5,13.9 18.5,10.1 16.2,7.7C15.1,6.6 13.5,6 12,6V10.6L7,5.6L12,0.6V4M6.3,17.6C3.7,15 3.3,11 5.1,7.9L6.6,9.4C5.5,11.6 5.9,14.4 7.8,16.2C8.3,16.7 8.9,17.1 9.6,17.4L9,19.4C8,19 7.1,18.4 6.3,17.6Z" />
                </svg>
              </div>
            </RouterLink>
          </td>
        </tr>
      </template>
    </VTable>
    <VTPagination v-model:currentPage="currentPage" :totalPages="totalPages" :boundaryLinks="true" v-if="totalPages > 1"
      class="w-full text-gray-700 mt-2 flex justify-center" />
  </template>
</template>

<style>
ul.pagination {
  display: flex;
  align-items: center;
}

ul.pagination>li {
  margin-right: 2px;
}
</style>

<script lang="ts" setup>
import { computed, ref } from "vue";
import { useSubmitStore } from "../../stores/submitStore";

const { setFromJobObject } = useSubmitStore();

const props = defineProps(["tableData", "loading", "rowClick"]);
const computedData = computed(() => props.tableData ?? []);

const emit = defineEmits(["clickRow"]);

const currentPage = ref(1);
const totalPages = ref(0);

const filter = ref({
  default: {
    value: "",
    keys: ["id", "alias"],
  },
});

const datetimeFilter = function (value: string): string {
  if (typeof value === "undefined") return "";

  const firstSplit = value.split("T");
  const secondSplit = firstSplit[1].split(".");
  return `${firstSplit[0]} ${secondSplit[0]}`;
};

const tableState = ref();
</script>
